/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * xesam-glib
 * Copyright (C) Mikkel Kamstrup Erlandsen 2007 <mikkel.kamstrup@gmail.com>
 * 
 * xesam-glib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * xesam-glib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with xesam-glib.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#ifndef __XESAM_G_DBUSSEARCHER_H__
#define __XESAM_G_DBUSSEARCHER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <dbus/dbus-glib.h>
#include <dbus/dbus.h>
#include "xesam-g-searcher.h"

G_BEGIN_DECLS


#define XESAM_TYPE_G_DBUS_SEARCHER (xesam_g_dbus_searcher_get_type ())
#define XESAM_G_DBUS_SEARCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XESAM_TYPE_G_DBUS_SEARCHER, XesamGDBusSearcher))
#define XESAM_G_DBUS_SEARCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XESAM_TYPE_G_DBUS_SEARCHER, XesamGDBusSearcherClass))
#define XESAM_IS_G_DBUS_SEARCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XESAM_TYPE_G_DBUS_SEARCHER))
#define XESAM_IS_G_DBUS_SEARCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XESAM_TYPE_G_DBUS_SEARCHER))
#define XESAM_G_DBUS_SEARCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XESAM_TYPE_G_DBUS_SEARCHER, XesamGDBusSearcherClass))

typedef struct _XesamGDBusSearcher XesamGDBusSearcher;
typedef struct _XesamGDBusSearcherClass XesamGDBusSearcherClass;
typedef struct _XesamGDBusSearcherPrivate XesamGDBusSearcherPrivate;

struct _XesamGDBusSearcher {
	GObject						parent;
	XesamGDBusSearcherPrivate	*priv;
};

struct _XesamGDBusSearcherClass {
	GObjectClass				parent;
};

XesamGDBusSearcher*		xesam_g_dbus_searcher_new_default	(void);

XesamGDBusSearcher*		xesam_g_dbus_searcher_new			(const gchar	*bus_name,
															 const gchar	*object_path);

GType					xesam_g_dbus_searcher_get_type		(void);

GQuark					xesam_g_dbus_error_quark			(void);

typedef enum
{
	XESAM_G_DBUS_ERROR_BROKEN_PROXY,/* Failed to create a dbus proxy */
	XESAM_G_DBUS_ERROR_NAME_LOST /* Failed to grab requested bus name */
} XesamGDBusError;

G_END_DECLS

#endif
