/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * xesam-glib
 * Copyright (C) Mikkel Kamstrup Erlandsen 2007 <mikkel.kamstrup@gmail.com>
 * 
 * xesam-glib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * xesam-glib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with xesam-glib.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#ifndef _XESAM_G_HIT_H_
#define _XESAM_G_HIT_H_

#include <glib-object.h>

G_BEGIN_DECLS

#define XESAM_TYPE_G_HIT             (xesam_g_hit_get_type ())
#define XESAM_G_HIT(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), XESAM_TYPE_G_HIT, XesamGHit))
#define XESAM_G_HIT_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), XESAM_TYPE_G_HIT, XesamGHitClass))
#define XESAM_IS_G_HIT(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XESAM_TYPE_G_HIT))
#define XESAM_IS_G_HIT_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), XESAM_TYPE_G_HIT))
#define XESAM_G_HIT_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XESAM_TYPE_G_HIT, XesamGHitClass))

/* Public structs */
typedef struct _XesamGHit XesamGHit;
typedef struct _XesamGHitClass XesamGHitClass;

/* Private structs */
typedef struct _XesamGHitPrivate XesamGHitPrivate;

struct _XesamGHitClass
{
	GObjectClass parent_class;
};

struct _XesamGHit
{
	GObject 			parent_instance;
	XesamGHitPrivate 	*priv;
};

/* Public methods */
GType 			 xesam_g_hit_get_type 				(void);

const GValue* 	 xesam_g_hit_get_field 				(XesamGHit *hit,
													 const gchar *field_name);

const gchar*	 xesam_g_hit_get_string				(XesamGHit	*hit,
													 const gchar	*field_name);

const GValue*	 xesam_g_hit_get_field_by_id 		(XesamGHit *hit,
													 guint field_id);

guint			 xesam_g_hit_get_id 				(XesamGHit *hit);

gchar**			 xesam_g_hit_get_field_names		(XesamGHit	*hit);

const GPtrArray* xesam_g_hit_get_data				(XesamGHit	*hit);

G_END_DECLS

#endif /* _XESAM_G_HIT_H_ */
