/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * xesam-glib
 * Copyright (C) Mikkel Kamstrup Erlandsen 2007 <mikkel.kamstrup@gmail.com>
 * 
 * xesam-glib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * xesam-glib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with xesam-glib.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#ifndef _XESAM_G_HITS_H_
#define _XESAM_G_HITS_H_

#include <glib-object.h>
#include <xesam-glib/xesam-g-hit.h>

G_BEGIN_DECLS

#define XESAM_TYPE_G_HITS             (xesam_g_hits_get_type ())
#define XESAM_G_HITS(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), XESAM_TYPE_G_HITS, XesamGHits))
#define XESAM_G_HITS_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), XESAM_TYPE_G_HITS, XesamGHitsClass))
#define XESAM_IS_G_HITS(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XESAM_TYPE_G_HITS))
#define XESAM_IS_G_HITS_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), XESAM_TYPE_G_HITS))
#define XESAM_G_HITS_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XESAM_TYPE_G_HITS, XesamGHitsClass))

/* Public structs */
typedef struct _XesamGHits XesamGHits;
typedef struct _XesamGHitsClass XesamGHitsClass;

/* Private structs */
typedef struct _XesamGHitsPrivate XesamGHitsPrivate;

struct _XesamGHitsClass
{
	GObjectClass parent_class;
};

struct _XesamGHits
{
	GObject 			parent_instance;
	XesamGHitsPrivate	*priv;
};

GType 			xesam_g_hits_get_type 	(void);

guint 			xesam_g_hits_get_count 	(XesamGHits* hits);

XesamGHit*		xesam_g_hits_get 		(XesamGHits *hits,
										 guint offset);


G_END_DECLS

#endif /* _XESAM_G_HITS_H_ */
