/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * xesam-glib
 * Copyright (C) Mikkel Kamstrup Erlandsen 2007 <mikkel.kamstrup@gmail.com>
 * 
 * xesam-glib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * xesam-glib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with xesam-glib.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#ifndef _XESAM_G_QUERY_H_
#define _XESAM_G_QUERY_H_

#include <glib-object.h>

G_BEGIN_DECLS

#define XESAM_TYPE_G_QUERY             (xesam_g_query_get_type ())
#define XESAM_G_QUERY(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), XESAM_TYPE_G_QUERY, XesamGQuery))
#define XESAM_G_QUERY_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), XESAM_TYPE_G_QUERY, XesamGQueryClass))
#define XESAM_IS_G_QUERY(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XESAM_TYPE_G_QUERY))
#define XESAM_IS_G_QUERY_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), XESAM_TYPE_G_QUERY))
#define XESAM_G_QUERY_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XESAM_TYPE_G_QUERY, XesamGQueryClass))

/* Public structs */
typedef struct _XesamGQuery XesamGQuery;
typedef struct _XesamGQueryClass XesamGQueryClass;

/* Private structs */
typedef struct _XesamGQueryPrivate XesamGQueryPrivate;

struct _XesamGQueryClass
{
	GObjectClass parent_class;
};

struct _XesamGQuery
{
	GObject 			parent_instance;
	XesamGQueryPrivate 	*priv;
};

// Public methods
GType 			xesam_g_query_get_type 			(void);

const gchar*	xesam_g_query_get_xml 			(XesamGQuery *query);

XesamGQuery* 	xesam_g_query_new_from_text 	(const gchar *search_text);

XesamGQuery* 	xesam_g_query_new_from_textf	(const gchar *format, ...);

XesamGQuery* 	xesam_g_query_new_from_xml 		(const gchar *query_xml);

G_END_DECLS

#endif /* _XESAM_G_QUERY_H_ */
