/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * xesam-glib
 * Copyright (C) Mikkel Kamstrup Erlandsen 2007 <mikkel.kamstrup@gmail.com>
 * 
 * xesam-glib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * xesam-glib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with xesam-glib.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#ifndef _XESAM_GLIB_GLOBALS_H_
#define _XESAM_GLIB_GLOBALS_H_

G_BEGIN_DECLS

#define XESAM_G_SERVER_DBUS_NAME "org.freedesktop.xesam.searcher"
#define XESAM_G_SERVER_DBUS_INTERFACE "org.freedesktop.xesam.Search"
#define XESAM_G_SERVER_DBUS_OBJECT "/org/freedesktop/xesam/searcher/main"

/* Session methods */
#define XESAM_G_METHOD_NewSession 	"NewSession"
#define XESAM_G_METHOD_CloseSession "CloseSession"
#define XESAM_G_METHOD_GetProperty 	"GetProperty"
#define XESAM_G_METHOD_SetProperty 	"SetProperty"

/* Search methods and signals */
#define XESAM_G_METHOD_NewSearch 	"NewSearch"
#define XESAM_G_METHOD_StartSearch 	"StartSearch"
#define XESAM_G_METHOD_CloseSearch 	"CloseSearch"
#define XESAM_G_METHOD_GetHits 		"GetHits"
#define XESAM_G_METHOD_GetHitData 	"GetHitData"
#define XESAM_G_METHOD_GetHitCount 	"GetHitCount"
#define XESAM_G_SIGNAL_HitsAdded 	"HitsAdded"
#define XESAM_G_SIGNAL_HitsModified "HitsModified"
#define XESAM_G_SIGNAL_HitsRemoved 	"HitsRemoved"
#define XESAM_G_SIGNAL_SearchDone 	"SearchDone"

/* State info methods */
#define XESAM_G_METHOD_GetState 	"GetState"
#define XESAM_G_SIGNAL_StateChanged "StateChanged"

/* Extra types needed */
#define XESAM_TYPE_STRV_ARRAY (dbus_g_type_get_collection ("GPtrArray", G_TYPE_STRV))
#define XESAM_TYPE_VALUE_ARRAY_ARRAY (dbus_g_type_get_collection ("GPtrArray", dbus_g_type_get_collection("GPtrArray", G_TYPE_VALUE)))
#define XESAM_TYPE_UINT_ARRAY (DBUS_TYPE_G_UINT_ARRAY)

/* GError definitions */
#define XESAM_G_ERROR xesam_g_error_quark ()
#define XESAM_G_DBUS_ERROR xesam_g_dbus_error_quark ()
GQuark xesam_g_error_quark (void);

G_END_DECLS

#endif /* _XESAM_GLIB_GLOBALS_H_ */
